using System;
using System.Collections.Generic;
using System.Text;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Shapes;
using System.Windows.Threading;


namespace CollectionViewInfragistics
{
    /// <summary>
    /// Interaction logic for Window1.xaml
    /// </summary>

    public partial class Window1 : System.Windows.Window
    {
        private static decimal[] _values = new decimal[] { 0, 1, 2, 3, 4, 5 };

        private readonly Random _rnd = new Random();
        private ItemCollection _collection;
        private DispatcherTimer _timer;

        public Window1()
        {
            InitializeComponent();

            InitializeCollection();

            _grid.DataSource = new ItemCollectionView(_collection);

            InitializeTimer();

            Loaded += new RoutedEventHandler(OnWindowLoaded);
            Closing += new System.ComponentModel.CancelEventHandler(OnWindowClosing);
        }

        private void InitializeTimer()
        {
            _timer = new DispatcherTimer();
            _timer.Interval = TimeSpan.FromMilliseconds(4000);
            _timer.Tick += new EventHandler(OnTimerTick);
        }


        void OnTimerTick(object sender, EventArgs e)
        {
            _collection[0].Value = _values[_rnd.Next(_values.Length - 1)];
            _collection[1].Value = _values[_rnd.Next(_values.Length - 1)];
        }

        private void InitializeCollection()
        {
            _collection = new ItemCollection();

            Item item = new Item();
            item.Value = 1;
            _collection.Add(item);

            item = new Item();
            item.Value = 2;
            _collection.Add(item);
        }


        void OnWindowClosing(object sender, System.ComponentModel.CancelEventArgs e)
        {
            _timer.Stop();
        }

        void OnWindowLoaded(object sender, RoutedEventArgs e)
        {
            _timer.Start();
        }

    }
}